#pragma once

#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define FALSE 0
#define TRUE !FALSE

#define PI 3.14159265358979323846
#define SECOND 1000
#define MINUTE 60000

#define RAD_TO_DEG (180 / PI)
#define DEG_TO_RAD (PI / 180)

#define ROTATION_MAX_DEG 360
#define ROTATION_MAX_RAD (2 * PI)

#define FLOOR(x, f) x < f ? f : x
#define CEIL(x, c) x > c ? c : x
#define CLAMP(x, f, c) FLOOR(CEIL(x, c), f)

typedef uint8_t u8;
typedef uint16_t u16;
typedef uint32_t u32;
typedef uint64_t u64;

typedef int8_t s8;
typedef int16_t s16;
typedef int32_t s32;
typedef int64_t s64;

typedef float f32;
typedef double f64;

typedef u8 bool_u8;
