#include "atlas.h"

/* 
 * Initializes a given atlas, provided a 
 * texture, rows, columns, each frame's width, and 
 * each frame's height. 
*/
void
atlas_init(Atlas* _a, SDL_Texture* _t, s32 _r, s32 _c, s32 _fW, s32 _fH)
{
        memset(_a, '\0', sizeof(Atlas));

	_a->texture = _t;
	_a->rows = _r;
	_a->cols = _c;
	_a->frameW = _fW;
	_a->frameH = _fH;
}

/*
 * Returns the source rectangle of an atlas provided a frame;
 * where it's currently "focused" on.
*/
SDL_Rect
atlas_source_rect_get(Atlas* _a, s32 _f)
{
	SDL_Rect r;

	r.w = _a->frameW;
	r.h = _a->frameH;

	if (_a->cols == 1)
		r.x = 0;
	else
		r.x = (_f % _a->cols) * _a->frameW;

	if (_a->rows == 1)
		r.y = 0;
	else
		r.y = (_f / _a->rows) * _a->frameH;

	return r;
}
