#include "event.h"

/* Updates events. */
void
event_update(Event* _e)
{
        SDL_Event event;

        memcpy(&_e->prev, &_e->curr, EVENT_MAX);
        memset(&_e->curr, '\0', EVENT_MAX);

        while (SDL_PollEvent(&event))
        {
                switch (event.type)
                {
                        case SDL_QUIT:
                                _e->curr[EVENT_QUIT] = TRUE;
                                break;
                        default:
                                break;
                }
        }
}

/* Is a given event pressed? */
bool_u8
event_press(Event* _e, EventType _t)
{
        return (_e->curr[_t] && !_e->prev[_t]);
}

/* Is a given event held? */
bool_u8
event_held(Event* _e, EventType _t)
{
        return (_e->curr[_t] && _e->prev[_t]);
}

/* Is a given event released? */
bool_u8
event_release(Event* _e, EventType _t)
{
        return (!_e->curr[_t] && _e->prev[_t]);
}
