#include "keyboard.h"

/* Updates the keyboard. */
void
keyboard_update(Keyboard* _k)
{
	const u8* state;

	memcpy(&_k->prev, &_k->curr, KEYBOARD_MAX);
	memset(&_k->curr, '\0', KEYBOARD_MAX);

	state = SDL_GetKeyboardState(NULL);

	memcpy(&_k->curr, state, KEYBOARD_MAX);
}

/* Is the given key pressed? */
bool_u8
keyboard_press(Keyboard* _k, KeyboardType _t)
{
	return (_k->curr[_t] && !_k->prev[_t]);
}

/* Is the given key held? */
bool_u8
keyboard_held(Keyboard* _k, KeyboardType _t)
{
	return (_k->curr[_t] && _k->prev[_t]);
}

/* Is the given key released? */
bool_u8
keyboard_release(Keyboard* _k, KeyboardType _t)
{
	return (!_k->curr[_t] && _k->prev[_t]);
}
