#include "mouse.h"

/* Updates the mouse. */
void
mouse_update(Mouse* _m)
{
        s32 state;

        memcpy(&_m->prev, &_m->curr, MOUSE_MAX);
        memset(&_m->curr, '\0', MOUSE_MAX);

        state = SDL_GetMouseState(NULL, NULL);

        if ((state & SDL_BUTTON_LMASK) != 0)
                _m->curr[MOUSE_LEFT] = TRUE;

        if ((state & SDL_BUTTON_MMASK) != 0)
                _m->curr[MOUSE_MIDDLE] = TRUE;

        if ((state & SDL_BUTTON_RMASK) != 0)
                _m->curr[MOUSE_RIGHT] = TRUE;

	SDL_GetMouseState(&_m->x, &_m->y);
}

/* Is a given mouse button pressed? */
bool_u8
mouse_press(Mouse* _m, MouseType _t)
{
        return (_m->curr[_t] && !_m->prev[_t]);
}

/* Is a given mouse button held? */
bool_u8
mouse_held(Mouse* _m, MouseType _t)
{
        return (_m->curr[_t] && _m->prev[_t]);
}

/* Is a given mouse button released? */
bool_u8
mouse_release(Mouse* _m, MouseType _t)
{
        return (!_m->curr[_t] && _m->prev[_t]);
}
