#pragma once

#include <SDL2/SDL.h>

#include "../COMMON.h"

#define MOUSE_MAX 4

typedef enum MouseType
{
	MOUSE_NONE,
	MOUSE_LEFT,
	MOUSE_MIDDLE,
	MOUSE_RIGHT
} MouseType;

typedef struct Mouse
{
	s32 x;
	s32 y;
	bool_u8 curr[MOUSE_MAX];
	bool_u8 prev[MOUSE_MAX];
} Mouse;

void mouse_update(Mouse* _m);
bool_u8 mouse_press(Mouse* _m, MouseType _t);
bool_u8 mouse_held(Mouse* _m, MouseType _t);
bool_u8 mouse_release(Mouse* _m, MouseType _t);
