#include "music.h"

/* Returns music from a filepath. */
void
music_init(Mix_Music** _x, char* _p)
{
	*_x = Mix_LoadMUS(_p);
}

/* Frees given music. */
void
music_free(Mix_Music* _x)
{
	Mix_FreeMusic(_x);
}

/* Plays a given music. */
void
music_play(Mix_Music* _x, bool_u8 _l)
{
	if (_l)
		Mix_PlayMusic(_x, -1);
	else
		Mix_PlayMusic(_x, 0);
}

/* Stops whatever music is playing. */
void
music_stop(void)
{
	Mix_HaltMusic();
}

/* Is music currently playing? */
bool_u8
music_playing(void)
{
	return Mix_PlayingMusic();
}
