#include "rectangle.h"

/* Draws a rectangle onto a renderer, given a rectangle and color. */
void
rectangle_draw(SDL_Rect* _x, SDL_Renderer* _r, SDL_Color _c)
{
	SDL_Color c;

	c = renderer_color_get(_r);

	renderer_color_set(_r, _c);

	SDL_RenderFillRect(_r, _x);

	renderer_color_set(_r, c);
}

/* Is a point colliding with a rectangle? */
bool_u8
rectangle_point_collide(SDL_Rect* _r, f64 _x, f64 _y)
{
	SDL_Point p;

	p.x = _x;
	p.y = _y;

	if (SDL_PointInRect(&p, _r))
		return TRUE;
	return FALSE;
}
