#pragma once

#include "atlas.h"

#define SPRITE_SCALE_DEFAULT 1.0
#define SPRITE_SQUASH_DEFAULT 1.0
#define SPRITE_STRETCH_DEFAULT 1.0
#define SPRITE_FRAME_DEFAULT 0
#define SPRITE_ROTATION_DEFAULT 0.0

typedef enum OriginType
{
	ORIGIN_NONE,
        ORIGIN_TOP_LEFT,
        ORIGIN_MIDDLE
} OriginType;

typedef enum FlipType
{
	FLIP_NONE,
	FLIP_HORIZONTAL,
	FLIP_VERTICAL,
	FLIP_HORIZONTAL_VERTICAL
} FlipType;

typedef struct Sprite
{
	FlipType flip;
        OriginType origin;
        f64 rotation;
        f64 scale;
	f64 squash;
	f64 stretch;
        f64 x;
        f64 y;
        s32 frame;
        s32 h;
        s32 w;
        Atlas atlas;
        SDL_Color color;
} Sprite;

static const SDL_Color SPRITE_COLOR_DEFAULT = {255, 255, 255, 255};

SDL_Rect sprite_rect_get(Sprite* _x);
void sprite_atlas_init(Sprite* _x, Atlas* _a, OriginType _o, s32 _w, s32 _h);
void sprite_init(Sprite* _x, SDL_Texture* _t, OriginType _o, s32 _w, s32 _h);
void sprite_draw(Sprite* _x, SDL_Renderer* _r);
void sprite_free(Sprite* _x);
