#include "texture.h"

/* Initializes a texture, given a renderer and a path. */
void
texture_init(SDL_Texture** _x, SDL_Renderer* _r, char* _p)
{
	*_x = IMG_LoadTexture(_r, _p);
}

/* Frees a given texture. */
void
texture_free(SDL_Texture* _x)
{
	SDL_DestroyTexture(_x);
}

/* Returns a texture's width. */
s32
texture_w_get(SDL_Texture* _x)
{
	s32 w;

	SDL_QueryTexture(_x, NULL, NULL, &w, NULL);

	return w;
}

/* Returns a texture's height. */
s32
texture_h_get(SDL_Texture* _x)
{
	s32 h;

	SDL_QueryTexture(_x, NULL, NULL, NULL, &h);

	return h;
}
