/*
 * DESCRIPTION:
 * Header file for ending_fail.c.
*/

#pragma once

#include "../gui/button.h"
#include "../gui/cursor.h"
#include "../scene/scene.h"
#include "../GAME_STRINGS.h"

#define ENDING_FAIL_SCENE_COUNT 1
#define ENDING_ONE_SCENE_COUNT 1
#define ENDING_TWO_SCENE_COUNT 1
#define ENDING_THREE_SCENE_COUNT 1

#define ENDING_PLUS_BUTTON_OFFSET_X 150
#define ENDING_PLUS_BUTTON_OFFSET_Y 550
#define ENDING_END_BUTTON_OFFSET_X 600
#define ENDING_END_BUTTON_OFFSET_Y 550

#define ENDING_TWO_CASH_THRESHOLD 50000
#define ENDING_THREE_CASH_THRESHOLD 100000

static const Scene ENDING_FAIL_SCENES[ENDING_FAIL_SCENE_COUNT] = 
{
	{
		.textureType = TEXTURE_ENDING_FAIL,
		.text = STRING_ENDING_FAIL
	}
};

static const Scene ENDING_ONE_SCENES[ENDING_ONE_SCENE_COUNT] = 
{
	{
		.textureType = TEXTURE_ENDING_ONE,
		.text = STRING_ENDING_ONE
	}
};

static const Scene ENDING_TWO_SCENES[ENDING_TWO_SCENE_COUNT] = 
{
	{
		.textureType = TEXTURE_ENDING_TWO,
		.text = STRING_ENDING_TWO
	}
};

static const Scene ENDING_THREE_SCENES[ENDING_THREE_SCENE_COUNT] = 
{
	{
		.textureType = TEXTURE_ENDING_THREE,
		.text = STRING_ENDING_THREE
	}
};

static const SDL_Color ENDING_TEXT_COLOR = {255, 255, 255, 255};

void ending_update(Ending* _e);
void ending_init(Ending* _e, Game* _g, EndingType _t);
void ending_draw(Ending* _e);
void ending_free(Ending* _e);
