/*
 * DESCRIPTION:
 * The "Title" state's meta functions. 
*/

#include "game_ending.h"

/* Initializes the Intro state's resources. */
void
game_ending_init(Game* _g)
{
	for (s32 i = 0; i < ENDING_TEXTURE_COUNT; i++)
	{
		s32 index;

		index = ENDING_TEXTURES[i];

		game_texture_init(_g, (TextureType)index);
	}

	for (s32 i = 0; i < ENDING_SOUND_COUNT; i++)
	{
		s32 index;

		index = ENDING_SOUNDS[i];

		game_sound_init(_g, (SoundType)index);
	}

	for (s32 i = 0; i < ENDING_FONT_COUNT; i++)
	{
		s32 index;

		index = ENDING_FONTS[i];

		game_font_init(_g, (FontType)index);
	}

	for (s32 i = 0; i < ENDING_MUSIC_COUNT; i++)
	{
		s32 index;

		index = ENDING_MUSIC[i];

		game_music_init(_g, (MusicType)index);
	}
}

/* Frees the Intro state's resources. */
void
game_ending_free(Game* _g)
{
	for (s32 i = 0; i < ENDING_TEXTURE_COUNT; i++)
	{
		s32 index;

		index = ENDING_TEXTURES[i];

		game_texture_free(_g, (TextureType)index);
	}

	for (s32 i = 0; i < ENDING_SOUND_COUNT; i++)
	{
		s32 index;

		index = ENDING_SOUNDS[i];

		game_sound_free(_g, (SoundType)index);
	}

	for (s32 i = 0; i < ENDING_FONT_COUNT; i++)
	{
		s32 index;

		index = ENDING_FONTS[i];

		game_font_free(_g, (FontType)index);
	}

	for (s32 i = 0; i < ENDING_MUSIC_COUNT; i++)
	{
		s32 index;

		index = ENDING_MUSIC[i];

		game_music_free(_g, (MusicType)index);
	}
}

/* Updates the Intro state. */
void
game_ending_update(Game* _g)
{
	ending_update(&_g->ending);
}

/* Draws the Intro state. */
void
game_ending_draw(Game* _g)
{
	ending_draw(&_g->ending);
}
