/*
 * DESCRIPTION:
 * Header file for game_ending.c.
*/

#pragma once

#include "ending/ending.h"

#include "game_font.h"
#include "game_music.h"
#include "game_sound.h"
#include "game_texture.h"

#define ENDING_TEXTURE_COUNT 5
#define ENDING_SOUND_COUNT 2
#define ENDING_MUSIC_COUNT 1
#define ENDING_FONT_COUNT 2

static const TextureType ENDING_TEXTURES[ENDING_TEXTURE_COUNT] = 
{
	TEXTURE_ENDING_FAIL,
	TEXTURE_ENDING_ONE,
	TEXTURE_ENDING_TWO,
	TEXTURE_ENDING_THREE,
	TEXTURE_GUI_CURSOR
};

static const SoundType ENDING_SOUNDS[ENDING_SOUND_COUNT] = 
{
	SOUND_BLIP,
	SOUND_MENU
};

static const MusicType ENDING_MUSIC[ENDING_MUSIC_COUNT] = 
{
	MUSIC_WIND
};

static const FontType ENDING_FONTS[ENDING_FONT_COUNT] = 
{
	FONT_SMALL,
	FONT_BIG
};

void game_ending_draw(Game* _g);
void game_ending_free(Game* _g);
void game_ending_init(Game* _g);
void game_ending_update(Game* _g);
