/*
 * DESCRIPTION:
 * Loads/frees game fonts.
*/

#include "game_font.h"

/* Loads a game font. */
void
game_font_init(Game* _g, FontType _f)
{
	if (!_g->fonts[_f])
        	font_init(&_g->fonts[_f], (char*)FONT_PATHS[_f], (s32)FONT_SIZES[_f]);
}

/* Frees a game font. */
void
game_font_free(Game* _g, FontType _f)
{
	if (_g->fonts[_f])
	{
		font_free(_g->fonts[_f]);
		_g->fonts[_f] = NULL;
	}
}

/* Clears all fonts. */
void
game_font_clear(Game* _g)
{
        for (s32 i = 0; i < FONT_COUNT; i++)
        {
                if (_g->fonts[i])
                        game_font_free(_g, (FontType)i);
        }
}

