/*
 * DESCRIPTION:
 * The "Info" state's meta functions. 
*/

#include "game_info.h"

/* Initializes the Play state's resources. */
void
game_info_init(Game* _g)
{
	for (s32 i = 0; i < INFO_TEXTURE_COUNT; i++)
	{
		s32 index;

		index = INFO_TEXTURES[i];

		game_texture_init(_g, (TextureType)index);
	}

	for (s32 i = 0; i < INFO_SOUND_COUNT; i++)
	{
		s32 index;

		index = INFO_SOUNDS[i];

		game_sound_init(_g, (SoundType)index);
	}

	for (s32 i = 0; i < INFO_FONT_COUNT; i++)
	{
		s32 index;

		index = INFO_FONTS[i];

		game_font_init(_g, (FontType)index);
	}

	for (s32 i = 0; i < INFO_MUSIC_COUNT; i++)
	{
		s32 index;

		index = INFO_MUSIC[i];

		game_music_init(_g, (MusicType)index);
	}

	info_init(&_g->info, _g);
}

/* Frees the Play state's resources. */
void
game_info_free(Game* _g)
{
	info_free(&_g->info);

	for (s32 i = 0; i < INFO_TEXTURE_COUNT; i++)
	{
		s32 index;

		index = INFO_TEXTURES[i];

		game_texture_free(_g, (TextureType)index);
	}

	for (s32 i = 0; i < INFO_SOUND_COUNT; i++)
	{
		s32 index;

		index = INFO_SOUNDS[i];

		game_sound_free(_g, (SoundType)index);
	}

	for (s32 i = 0; i < INFO_FONT_COUNT; i++)
	{
		s32 index;

		index = INFO_FONTS[i];

		game_font_free(_g, (FontType)index);
	}

	for (s32 i = 0; i < INFO_MUSIC_COUNT; i++)
	{
		s32 index;

		index = INFO_MUSIC[i];

		game_music_free(_g, (MusicType)index);
	}
}

/* Updates the Play state. */
void
game_info_update(Game* _g)
{
	info_update(&_g->info);
}

/* Draws the Play state. */
void
game_info_draw(Game* _g)
{
	info_draw(&_g->info);
}
