/*
 * DESCRIPTION:
 * Header file for game_info.c.
*/

#pragma once

#include "info/info.h"

#include "game_font.h"
#include "game_music.h"
#include "game_sound.h"
#include "game_texture.h"

#define INFO_TEXTURE_COUNT 6
#define INFO_SOUND_COUNT 1
#define INFO_MUSIC_COUNT 1
#define INFO_FONT_COUNT 4

static const TextureType INFO_TEXTURES[INFO_TEXTURE_COUNT] = 
{
	TEXTURE_GUI_SIGN_SMALL,
	TEXTURE_GUI_CURSOR,
	TEXTURE_INFO_THEME,
	TEXTURE_INFO_WILDCARD_ADMIN,
	TEXTURE_INFO_WILDCARD_PATREON,
	TEXTURE_INFO_WILDCARD_COMMUNITY
};

static const SoundType INFO_SOUNDS[INFO_SOUND_COUNT] = 
{
	SOUND_MENU
};

static const MusicType INFO_MUSIC[INFO_MUSIC_COUNT] = 
{
	MUSIC_TITLE
};

static const FontType INFO_FONTS[INFO_FONT_COUNT] = 
{
	FONT_TINY,
	FONT_SMALL,
	FONT_MEDIUM,
	FONT_BIG
};

void game_info_draw(Game* _g);
void game_info_free(Game* _g);
void game_info_init(Game* _g);
void game_info_update(Game* _g);
