/*
 * DESCRIPTION:
 * The "Title" state's meta functions. 
*/

#include "game_intro.h"

/* Initializes the Intro state's resources. */
void
game_intro_init(Game* _g)
{
	for (s32 i = 0; i < INTRO_TEXTURE_COUNT; i++)
	{
		s32 index;

		index = INTRO_TEXTURES[i];

		game_texture_init(_g, (TextureType)index);
	}

	for (s32 i = 0; i < INTRO_SOUND_COUNT; i++)
	{
		s32 index;

		index = INTRO_SOUNDS[i];

		game_sound_init(_g, (SoundType)index);
	}

	for (s32 i = 0; i < INTRO_FONT_COUNT; i++)
	{
		s32 index;

		index = INTRO_FONTS[i];

		game_font_init(_g, (FontType)index);
	}

	for (s32 i = 0; i < INTRO_MUSIC_COUNT; i++)
	{
		s32 index;

		index = INTRO_MUSIC[i];

		game_music_init(_g, (MusicType)index);
	}
}

/* Frees the Intro state's resources. */
void
game_intro_free(Game* _g)
{
	for (s32 i = 0; i < INTRO_TEXTURE_COUNT; i++)
	{
		s32 index;

		index = INTRO_TEXTURES[i];

		game_texture_free(_g, (TextureType)index);
	}

	for (s32 i = 0; i < INTRO_SOUND_COUNT; i++)
	{
		s32 index;

		index = INTRO_SOUNDS[i];

		game_sound_free(_g, (SoundType)index);
	}

	for (s32 i = 0; i < INTRO_FONT_COUNT; i++)
	{
		s32 index;

		index = INTRO_FONTS[i];

		game_font_free(_g, (FontType)index);
	}

	for (s32 i = 0; i < INTRO_MUSIC_COUNT; i++)
	{
		s32 index;

		index = INTRO_MUSIC[i];

		game_music_free(_g, (MusicType)index);
	}
}

/* Updates the Intro state. */
void
game_intro_update(Game* _g)
{
	intro_update(&_g->intro);
}

/* Draws the Intro state. */
void
game_intro_draw(Game* _g)
{
	intro_draw(&_g->intro);
}
