/*
 * DESCRIPTION:
 * Header file for game_intro.c.
*/

#pragma once

#include "intro/intro.h"

#include "game_font.h"
#include "game_music.h"
#include "game_sound.h"
#include "game_texture.h"

#define INTRO_TEXTURE_COUNT 5
#define INTRO_SOUND_COUNT 2
#define INTRO_MUSIC_COUNT 1
#define INTRO_FONT_COUNT 1

static const TextureType INTRO_TEXTURES[INTRO_TEXTURE_COUNT] = 
{
	TEXTURE_INTRO_SCENE_ONE,
	TEXTURE_INTRO_SCENE_TWO,
	TEXTURE_INTRO_SCENE_THREE,
	TEXTURE_INTRO_SCENE_FOUR,
	TEXTURE_INTRO_SCENE_FIVE,
};

static const SoundType INTRO_SOUNDS[INTRO_SOUND_COUNT] = 
{
	SOUND_BLIP,
	SOUND_MENU
};

static const MusicType INTRO_MUSIC[INTRO_MUSIC_COUNT] = 
{
	MUSIC_INTRO
};

static const FontType INTRO_FONTS[INTRO_FONT_COUNT] = 
{
	FONT_SMALL
};

void game_intro_draw(Game* _g);
void game_intro_free(Game* _g);
void game_intro_init(Game* _g);
void game_intro_update(Game* _g);
