/*
 * DESCRIPTION:
 * Loads/frees game music.
*/

#include "game_music.h"

/* Loads a game music. */
void
game_music_init(Game* _g, MusicType _m)
{
        if (!_g->music[_m])
		music_init(&_g->music[_m], (char*)MUSIC_PATHS[_m]);
}

/* Frees a game music. */
void
game_music_free(Game* _g, MusicType _m)
{
	if (_g->music[_m])
	{
		music_free(_g->music[_m]);
		_g->music[_m] = NULL;
	}
}

/* Clears all music. */
void
game_music_clear(Game* _g)
{
	for (s32 i = 0; i < MUSIC_COUNT; i++)
	{
		if (_g->music[i])
			game_music_free(_g, (MusicType)i);
	}
}
