/*
 * DESCRIPTION:
 * The "Play" state's meta functions. 
*/

#include "game_play.h"

/* Initializes the Play state's resources. */
void
game_play_init(Game* _g)
{
	for (s32 i = 0; i < PLAY_TEXTURE_COUNT; i++)
	{
		s32 index;

		index = PLAY_TEXTURES[i];

		game_texture_init(_g, (TextureType)index);
	}

	for (s32 i = 0; i < PLAY_SOUND_COUNT; i++)
	{
		s32 index;

		index = PLAY_SOUNDS[i];

		game_sound_init(_g, (SoundType)index);
	}

	for (s32 i = 0; i < PLAY_FONT_COUNT; i++)
	{
		s32 index;

		index = PLAY_FONTS[i];

		game_font_init(_g, (FontType)index);
	}

	for (s32 i = 0; i < PLAY_MUSIC_COUNT; i++)
	{
		s32 index;

		index = PLAY_MUSIC[i];

		game_music_init(_g, (MusicType)index);
	}
}

/* Frees the Play state's resources. */
void
game_play_free(Game* _g)
{
	for (s32 i = 0; i < PLAY_TEXTURE_COUNT; i++)
	{
		s32 index;

		index = PLAY_TEXTURES[i];

		game_texture_free(_g, (TextureType)index);
	}

	for (s32 i = 0; i < PLAY_SOUND_COUNT; i++)
	{
		s32 index;

		index = PLAY_SOUNDS[i];

		game_sound_free(_g, (SoundType)index);
	}

	for (s32 i = 0; i < PLAY_FONT_COUNT; i++)
	{
		s32 index;

		index = PLAY_FONTS[i];

		game_font_free(_g, (FontType)index);
	}

	for (s32 i = 0; i < PLAY_MUSIC_COUNT; i++)
	{
		s32 index;

		index = PLAY_MUSIC[i];

		game_music_free(_g, (MusicType)index);
	}

}

/* Updates the Play state. */
void
game_play_update(Game* _g)
{
	play_update(&_g->play);
}

/* Draws the Play state. */
void
game_play_draw(Game* _g)
{
	play_draw(&_g->play);
}
