/*
 * DESCRIPTION:
 * Header file for game_play.c.
*/

#pragma once

#include "play/play.h"

#include "game_font.h"
#include "game_music.h"
#include "game_sound.h"
#include "game_texture.h"

#define PLAY_TEXTURE_COUNT 29
#define PLAY_SOUND_COUNT 23
#define PLAY_MUSIC_COUNT 4
#define PLAY_FONT_COUNT 5

static const TextureType PLAY_TEXTURES[PLAY_TEXTURE_COUNT] = 
{
	TEXTURE_GUI_CURSOR,
	TEXTURE_GUI_SNAKE,
	TEXTURE_GUI_REDIRECT,
	TEXTURE_GUI_CASH,
	TEXTURE_GUI_UPGRADE_SNAKE,
	TEXTURE_GUI_UPGRADE_LIFETIME,
	TEXTURE_GUI_UPGRADE_REDIRECT,
	TEXTURE_GUI_SIGN_SMALL,
	TEXTURE_GUI_SIGN_BIG,
	TEXTURE_SHADOW,
	TEXTURE_ARC,
	TEXTURE_PLAY_BG,
	TEXTURE_PLAYER_STAGE_ONE,
	TEXTURE_PLAYER_STAGE_TWO,
	TEXTURE_PLAYER_STAGE_THREE,
	TEXTURE_PLAYER_TAIL_STAGE_ONE,
	TEXTURE_PLAYER_TAIL_STAGE_TWO,
	TEXTURE_PLAYER_TAIL_STAGE_THREE,
	TEXTURE_PLAYER_SNAKE,
	TEXTURE_ENEMY_CUPPER,
	TEXTURE_ENEMY_CHIPPER,
	TEXTURE_ENEMY_CHIP,
	TEXTURE_ENEMY_CRUMBLER,
	TEXTURE_COLLECTIBLE_DOLLARS,
	TEXTURE_COLLECTIBLE_SACK,
	TEXTURE_COLLECTIBLE_BULLIONS,
	TEXTURE_COLLECTIBLE_MIRACLE_CURE,
	TEXTURE_COLLECTIBLE_DYNAMITE,
	TEXTURE_COLLECTIBLE_BERSERK
};

static const SoundType PLAY_SOUNDS[PLAY_SOUND_COUNT] = 
{
	SOUND_MENU,
        SOUND_SNAKE_FIRE,
        SOUND_SNAKE_REDIRECT,
        SOUND_SNAKE_RETURN,
        SOUND_ENEMY_HURT,
        SOUND_CUPPER_KILL,
        SOUND_CHIPPER_KILL,
        SOUND_CRUMBLER_KILL,
        SOUND_CHIP_KILL,
        SOUND_RUMBLE,
        SOUND_COLLECTIBLE,
        SOUND_DOLLARS,
        SOUND_SACK,
        SOUND_BULLIONS,
        SOUND_PURCHASE,
        SOUND_MIRACLE_CURE,
        SOUND_DYNAMITE,
        SOUND_BERSERK,
        SOUND_SWALLOW,
        SOUND_GROWTH,
	SOUND_ERROR,
	SOUND_GO,
	SOUND_SPIT
};

static const MusicType PLAY_MUSIC[PLAY_MUSIC_COUNT] = 
{
	MUSIC_WIND,
	MUSIC_PLAY,
	MUSIC_WAVE_CLEAR,
	MUSIC_WAVE_FAIL
};

static const FontType PLAY_FONTS[PLAY_FONT_COUNT] = 
{
	FONT_TINY,
	FONT_SMALL,
	FONT_MEDIUM,
	FONT_BIG,
	FONT_MEGA
};

void game_play_draw(Game* _g);
void game_play_free(Game* _g);
void game_play_init(Game* _g);
void game_play_update(Game* _g);
