/*
 * DESCRIPTION:
 * The "Title" state's meta functions. 
*/

#include "game_results.h"

/* Initializes the Intro state's resources. */
void
game_results_init(Game* _g)
{
	for (s32 i = 0; i < RESULTS_TEXTURE_COUNT; i++)
	{
		s32 index;

		index = RESULTS_TEXTURES[i];

		game_texture_init(_g, (TextureType)index);
	}

	for (s32 i = 0; i < RESULTS_SOUND_COUNT; i++)
	{
		s32 index;

		index = RESULTS_SOUNDS[i];

		game_sound_init(_g, (SoundType)index);
	}

	for (s32 i = 0; i < RESULTS_FONT_COUNT; i++)
	{
		s32 index;

		index = RESULTS_FONTS[i];

		game_font_init(_g, (FontType)index);
	}

	for (s32 i = 0; i < RESULTS_MUSIC_COUNT; i++)
	{
		s32 index;

		index = RESULTS_MUSIC[i];

		game_music_init(_g, (MusicType)index);
	}
}

/* Frees the Intro state's resources. */
void
game_results_free(Game* _g)
{
	for (s32 i = 0; i < RESULTS_TEXTURE_COUNT; i++)
	{
		s32 index;

		index = RESULTS_TEXTURES[i];

		game_texture_free(_g, (TextureType)index);
	}

	for (s32 i = 0; i < RESULTS_SOUND_COUNT; i++)
	{
		s32 index;

		index = RESULTS_SOUNDS[i];

		game_sound_free(_g, (SoundType)index);
	}

	for (s32 i = 0; i < RESULTS_FONT_COUNT; i++)
	{
		s32 index;

		index = RESULTS_FONTS[i];

		game_font_free(_g, (FontType)index);
	}

	for (s32 i = 0; i < RESULTS_MUSIC_COUNT; i++)
	{
		s32 index;

		index = RESULTS_MUSIC[i];

		game_music_free(_g, (MusicType)index);
	}
}

/* Updates the Intro state. */
void
game_results_update(Game* _g)
{
	results_update(&_g->results);
}

/* Draws the Intro state. */
void
game_results_draw(Game* _g)
{
	results_draw(&_g->results);
}
