/*
 * DESCRIPTION:
 * Header file for game_results.c.
*/

#pragma once

#include "results/results.h"

#include "game_font.h"
#include "game_music.h"
#include "game_sound.h"
#include "game_texture.h"

#define RESULTS_TEXTURE_COUNT 1
#define RESULTS_SOUND_COUNT 1
#define RESULTS_MUSIC_COUNT 1
#define RESULTS_FONT_COUNT 2

static const TextureType RESULTS_TEXTURES[RESULTS_TEXTURE_COUNT] = 
{
	TEXTURE_RESULTS
};

static const SoundType RESULTS_SOUNDS[RESULTS_SOUND_COUNT] = 
{
	SOUND_MENU
};

static const MusicType RESULTS_MUSIC[RESULTS_MUSIC_COUNT] = 
{
	MUSIC_RESULTS
};

static const FontType RESULTS_FONTS[RESULTS_FONT_COUNT] = 
{
	FONT_BIG,
	FONT_MEGA
};

void game_results_draw(Game* _g);
void game_results_free(Game* _g);
void game_results_init(Game* _g);
void game_results_update(Game* _g);
