/*
 * DESCRIPTION:
 * Loads/frees game sounds.
*/

#include "game_sound.h"

/* Loads a game sound. */
void
game_sound_init(Game* _g, SoundType _s)
{
	if (!_g->sounds[_s])
       		sound_init(&_g->sounds[_s], (char*)SOUND_PATHS[_s]);
}

/* Frees a game sound. */
void
game_sound_free(Game* _g, SoundType _s)
{
	if (_g->sounds[_s])
	{
        	sound_free(_g->sounds[_s]);
		_g->sounds[_s] = NULL;
	}
}

/* Clears all sounds. */
void
game_sound_clear(Game* _g)
{
        for (s32 i = 0; i < SOUND_COUNT; i++)
        {
                if (_g->sounds[i])
                        game_sound_free(_g, (SoundType)i);
        }
}

