/*
 * DESCRIPTION:
 * Header file for game_state.c.
*/

#pragma once

#include "game_ending.h"
#include "game_info.h"
#include "game_play.h"
#include "game_intro.h"
#include "game_title.h"
#include "game_results.h"

#define STATE_TRANSITION_TIMER_MAX 30
#define STATE_TRANSITION_RECTANGLE_WIDTH 800
#define STATE_TRANSITION_RECTANGLE_HEIGHT 600

static const SDL_Color STATE_TRANSITION_COLOR = {0, 0, 0, 255};

void game_state_free(Game* _g);
void game_state_update(Game* _g);
void game_state_draw(Game* _g);
void game_state_transition(Game* _g, StateType _s, bool_u8 _i, bool_u8 _f, bool_u8 _rI, bool_u8 _rF);
