/*
 * DESCRIPTION:
 * Loads/frees game textures.
*/

#include "game_texture.h"

/* Loads a game texture. */
void
game_texture_init(Game* _g, TextureType _t)
{
	if (!_g->textures[_t])
        	texture_init(&_g->textures[_t], _g->renderer, (char*)TEXTURE_PATHS[_t]);
}

/* Frees a game texture. */
void
game_texture_free(Game* _g, TextureType _t)
{
	if (_g->textures[_t])
	{
        	texture_free(_g->textures[_t]);
		_g->textures[_t] = NULL;
	}
}

/* Clears all textures. */
void
game_texture_clear(Game* _g)
{
        for (s32 i = 0; i < TEXTURE_COUNT; i++)
        {
                if (_g->textures[i])
                        game_texture_free(_g, (TextureType)i);
        }
}

