/*
 * DESCRIPTION:
 * Header file for game_texture.c.
*/

#pragma once

#include "GAME_COMMON.h"

static const char* TEXTURE_PATHS[TEXTURE_COUNT] =
{
        "",
	"res/gfx/title/gfxLogo.png",
        "res/gfx/gui/gfxGuiCursor.png",
        "res/gfx/play/gui/gfxGuiSnake.png",
        "res/gfx/play/gui/gfxGuiRedirect.png",
        "res/gfx/play/gui/gfxGuiCash.png",
        "res/gfx/play/gui/gfxGuiUpgradeSnake.png",
        "res/gfx/play/gui/gfxGuiUpgradeLifetime.png",
        "res/gfx/play/gui/gfxGuiUpgradeRedirect.png",
        "res/gfx/gui/gfxGuiSignSmall.png",
        "res/gfx/gui/gfxGuiSignBig.png",
        "res/gfx/play/gfxShadow.png",
        "res/gfx/play/player/gfxArc.png",
        "res/gfx/play/bg/gfxPlayBG.png",
        "res/gfx/play/player/gfxPlayerStageOne.png",
        "res/gfx/play/player/gfxPlayerStageTwo.png",
        "res/gfx/play/player/gfxPlayerStageThree.png",
        "res/gfx/play/player/gfxPlayerTailStageOne.png",
        "res/gfx/play/player/gfxPlayerTailStageTwo.png",
        "res/gfx/play/player/gfxPlayerTailStageThree.png",
        "res/gfx/play/player/gfxPlayerSnake.png",
        "res/gfx/play/enemy/gfxEnemyCupper.png",
        "res/gfx/play/enemy/gfxEnemyChipper.png",
        "res/gfx/play/enemy/gfxEnemyChip.png",
        "res/gfx/play/enemy/gfxEnemyCrumbler.png",
        "res/gfx/play/collectible/gfxCollectibleDollars.png",
        "res/gfx/play/collectible/gfxCollectibleSack.png",
        "res/gfx/play/collectible/gfxCollectibleBullions.png",
        "res/gfx/play/collectible/gfxCollectibleMiracleCure.png",
        "res/gfx/play/collectible/gfxCollectibleDynamite.png",
        "res/gfx/play/collectible/gfxCollectibleBerserk.png",
	"res/gfx/info/gfxTheme.png",
	"res/gfx/info/gfxWildcardAdmin.png",
	"res/gfx/info/gfxWildcardPatreon.png",
	"res/gfx/info/gfxWildcardCommunity.png",
	"res/gfx/intro/gfxIntroSceneOne.png",
	"res/gfx/intro/gfxIntroSceneTwo.png",
	"res/gfx/intro/gfxIntroSceneThree.png",
	"res/gfx/intro/gfxIntroSceneFour.png",
	"res/gfx/intro/gfxIntroSceneFive.png",
	"res/gfx/ending/gfxEndingFail.png",
	"res/gfx/ending/gfxEndingOne.png",
	"res/gfx/ending/gfxEndingTwo.png",
	"res/gfx/ending/gfxEndingThree.png",
	"res/gfx/title/gfxTitleBG.png",
	"res/gfx/results/gfxResults.png",
};

void game_texture_init(Game* _g, TextureType _t);
void game_texture_free(Game* _g, TextureType _t);
void game_texture_clear(Game* _g);
