/*
 * DESCRIPTION:
 * The "Title" state's meta functions. 
*/

#include "game_title.h"

/* Initializes the Play state's resources. */
void
game_title_init(Game* _g)
{
	for (s32 i = 0; i < TITLE_TEXTURE_COUNT; i++)
	{
		s32 index;

		index = TITLE_TEXTURES[i];

		game_texture_init(_g, (TextureType)index);
	}

	for (s32 i = 0; i < TITLE_SOUND_COUNT; i++)
	{
		s32 index;

		index = TITLE_SOUNDS[i];

		game_sound_init(_g, (SoundType)index);
	}

	for (s32 i = 0; i < TITLE_FONT_COUNT; i++)
	{
		s32 index;

		index = TITLE_FONTS[i];

		game_font_init(_g, (FontType)index);
	}

	for (s32 i = 0; i < TITLE_MUSIC_COUNT; i++)
	{
		s32 index;

		index = TITLE_MUSIC[i];

		game_music_init(_g, (MusicType)index);
	}
}

/* Frees the Play state's resources. */
void
game_title_free(Game* _g)
{
	for (s32 i = 0; i < TITLE_TEXTURE_COUNT; i++)
	{
		s32 index;

		index = TITLE_TEXTURES[i];

		game_texture_free(_g, (TextureType)index);
	}

	for (s32 i = 0; i < TITLE_SOUND_COUNT; i++)
	{
		s32 index;

		index = TITLE_SOUNDS[i];

		game_sound_free(_g, (SoundType)index);
	}

	for (s32 i = 0; i < TITLE_FONT_COUNT; i++)
	{
		s32 index;

		index = TITLE_FONTS[i];

		game_font_free(_g, (FontType)index);
	}

	for (s32 i = 0; i < TITLE_MUSIC_COUNT; i++)
	{
		s32 index;

		index = TITLE_MUSIC[i];

		game_music_free(_g, (MusicType)index);
	}
}

/* Updates the Play state. */
void
game_title_update(Game* _g)
{
	title_update(&_g->title);
}

/* Draws the Play state. */
void
game_title_draw(Game* _g)
{
	title_draw(&_g->title);
}
