/*
 * DESCRIPTION:
 * Header file for game_title.c.
*/

#pragma once

#include "title/title.h"

#include "game_font.h"
#include "game_music.h"
#include "game_sound.h"
#include "game_texture.h"

#define TITLE_TEXTURE_COUNT 5
#define TITLE_SOUND_COUNT 1
#define TITLE_MUSIC_COUNT 1
#define TITLE_FONT_COUNT 2

static const TextureType TITLE_TEXTURES[TITLE_TEXTURE_COUNT] = 
{
	TEXTURE_LOGO,
	TEXTURE_GUI_SIGN_SMALL,
	TEXTURE_GUI_SIGN_BIG,
	TEXTURE_GUI_CURSOR,
	TEXTURE_TITLE_BACKGROUND
};

static const SoundType TITLE_SOUNDS[TITLE_SOUND_COUNT] = 
{
	SOUND_MENU
};

static const MusicType TITLE_MUSIC[TITLE_MUSIC_COUNT] = 
{
	MUSIC_TITLE
};

static const FontType TITLE_FONTS[TITLE_FONT_COUNT] = 
{
	FONT_MEDIUM,
	FONT_BIG
};

void game_title_draw(Game* _g);
void game_title_free(Game* _g);
void game_title_init(Game* _g);
void game_title_update(Game* _g);
