/*
 * DESCRIPTION:
 * Berserk powerup.
*/

#include "berserk.h"

/* Initializes the berserk. */
void 
berserk_init(Collectible* _c, List* _l, Play* _p)
{
	sprite_init
	(
		&_c->sprite,
		_p->g->textures[TEXTURE_COLLECTIBLE_BERSERK],
		ORIGIN_MIDDLE,
		BERSERK_WIDTH,
		BERSERK_HEIGHT
	);
}

/* What happens when you collect the berserk? */
void
berserk_collect(Collectible* _c, List* _l, Play* _p)
{
	_p->player.isPowerUp = TRUE;

	_p->player.isSnakeUpdate = TRUE;

	_p->player.powerUpTimer = BERSERK_PLAYER_TIMER_MAX;

	sound_play(_p->g->sounds[SOUND_BERSERK], -1);

	message_power_up_add(_c->sprite.x, _c->sprite.y, _p);
}
