/*
 * DESCRIPTION: 
 * Header file for collectible.c.
*/

#pragma once

#include "bullions.h"
#include "dollars.h"
#include "sack.h"
#include "berserk.h"
#include "dynamite.h"
#include "miracle_cure.h"

#define COLLECTIBLE_ACTIVE_TIMER_MAX 30
#define COLLECTIBLE_SHADOW_RADIUS 16
#define COLLECTIBLE_SHADOW_OFFSET_X 0
#define COLLECTIBLE_SHADOW_OFFSET_Y 16
#define COLLECTIBLE_FRICTION 0.90
#define COLLECTIBLE_VELOCITY 3
#define COLLECTIBLE_DISAPPEAR_THRESHOLD 60
#define COLLECTIBLE_DISAPPEAR_MODULO 5
#define COLLECTIBLE_LIFETIME 500

Collectible* collectible_add(List* _l, CollectibleType _c, f64 _x, f64 _y, Play* _p);
void collectible_remove(Collectible* _c, List* _l, Play* _p);
void collectible_update(Collectible* _c, List* _l, Play* _p);
void collectible_collect(Collectible* _c, List* _l, Play* _p);
