/*
 * DESCRIPTION:
 * Dynamite collectible; blows stuff up.
*/

#include "dynamite.h"

/* Initializes the dynamite. */
void 
dynamite_init(Collectible* _c, List* _l, Play* _p)
{
	sprite_init
	(
		&_c->sprite,
		_p->g->textures[TEXTURE_COLLECTIBLE_DYNAMITE],
		ORIGIN_MIDDLE,
		DYNAMITE_WIDTH,
		DYNAMITE_HEIGHT
	);
}

/* What happens when you collect the dynamite? */
void
dynamite_collect(Collectible* _c, List* _l, Play* _p)
{
	Enemy** enemies;
	s32 enemyCount;

	enemies = (Enemy**)list_data_get(&_p->enemies);
	enemyCount = _p->enemies.count;

	for (s32 i = 0; i < enemyCount; i++)
	{
		Enemy* e;

		e = enemies[i];

		enemy_damage(e, DYNAMITE_DAMAGE, &_p->enemies, _p);
	}

	free(enemies);

	message_dynamite_add(_c->sprite.x, _c->sprite.y, _p);

	sound_play(_p->g->sounds[SOUND_DYNAMITE], 3);
}
