/*
 * DESCRIPTION:
 * "Miracle Cure", heals you for one fatness.
*/

#include "miracle_cure.h"

/* Initializes the miracle cure. */
void 
miracle_cure_init(Collectible* _c, List* _l, Play* _p)
{
	sprite_init
	(
		&_c->sprite,
		_p->g->textures[TEXTURE_COLLECTIBLE_MIRACLE_CURE],
		ORIGIN_MIDDLE,
		MIRACLE_CURE_WIDTH,
		MIRACLE_CURE_HEIGHT
	);
}

/* What happens when you collect the miracle cure? */
void
miracle_cure_collect(Collectible* _c, List* _l, Play* _p)
{
	_p->player.fatness--;

	_p->player.isFatnessUpdate = TRUE;

	if (_p->player.fatness < 0)
	{
		_p->player.fatness = 0;

		player_cash_acquire(&_p->player, MIRACLE_CURE_CASH_VALUE, _p);

		sound_play(_p->g->sounds[SOUND_BULLIONS], -1);
	}
	else
	{
		message_miracle_cure_add(_c->sprite.x, _c->sprite.y, _p);

		sound_play(_p->g->sounds[SOUND_MIRACLE_CURE], -1);
	}
}
