/*
 * DESCRIPTION:
 * Header file for chipper.c.
*/

#pragma once

#include "../../GAME_COMMON.h"
#include "enemy.h"

#define CHIPPER_ANIMATION_MODULO 5
#define CHIPPER_ANIMATION_TIMER_MAX 15
#define CHIPPER_STRETCH_MULTIPLIER 0.05
#define CHIPPER_SQUASH_MULTIPLIER 0.05
#define CHIPPER_ATTACK_TIMER_MAX_BASE 120
#define CHIPPER_ATTACK_TIMER_MAX_GAME_MULTIPLIER 1
#define CHIPPER_ATTACK_TIMER_MAX_MIN 30
#define CHIPPER_SHADOW_OFFSET_X 0
#define CHIPPER_SHADOW_OFFSET_Y 16
#define CHIPPER_SHADOW_RADIUS 24
#define CHIPPER_HEALTH_BASE 5
#define CHIPPER_HEALTH_GAME_MULTIPLIER 2
#define CHIPPER_HEALTH_MAX 99
#define CHIPPER_HEIGHT 48
#define CHIPPER_ROWS 1
#define CHIPPER_COLUMNS 4
#define CHIPPER_RANGE_MAX 300
#define CHIPPER_RANGE_MIN 200
#define CHIPPER_VELOCITY 1
#define CHIPPER_WIDTH 64

void chipper_init(Enemy* _e, List* _l, Play* _p);
void chipper_set(Enemy* _e, List* _l, f64 _x, f64 _y, Play* _p);
void chipper_update(Enemy* _e, List* _l, Play* _p);
