/*
 * DESCRIPTION:
 * Game enemies.
*/

#include "enemy.h"

/* Initializes enemy list. */
void
enemies_init(List* _l, Play* _p)
{
	list_init(_l);
}

/* Frees enemy list. */
void
enemies_free(List* _l, Play* _p)
{
	list_free(_l);
}

/* Brutally murders all enemies. */
void
enemies_defeat(List* _l, Play* _p)
{
        Enemy** enemies;
	s32 count;

        enemies = (Enemy**)list_data_get(_l);
	count = _l->count;

        for (s32 i = 0; i < count; i++)
        {
                Enemy* e;

                e = enemies[i];

                enemy_defeat(e, _l, _p);
        }

        free(enemies);
}

/* Updates enemies. */
void
enemies_update(List* _l, Play* _p)
{
        Enemy** enemies;
	s32 count;

        enemies = (Enemy**)list_data_get(_l);
	count = _l->count;

        for (s32 i = 0; i < count; i++)
        {
                Enemy* e;

                e = enemies[i];

                enemy_update(e, _l, _p);
        }

        free(enemies);
}

/* Draws enemies. */
void
enemies_draw(List* _l, Play* _p)
{
	Enemy** enemies;
	s32 count;

        enemies = (Enemy**)list_data_get(_l);
	count = _l->count;

        for (s32 i = 0; i < count; i++)
        {
                Enemy* e;

                e = enemies[i];

		shadow_draw(&e->shadow, _p);
        }

        for (s32 i = 0; i < count; i++)
        {
                Enemy* e;

                e = enemies[i];

 		sprite_draw(&e->sprite, _p->g->renderer);
        }

        free(enemies);
}
