/*
 * DESCRIPTION:
 * Header file for enemy.h
*/

#pragma once

#include "../collectible/collectible.h"
#include "chip.h"
#include "chipper.h"
#include "crumbler.h"
#include "cupper.h"
#include "../message/message.h"

#define ENEMY_COLLECTIBLE_DROP_CHANCE_BASE 0.33
#define ENEMY_CHIPPER_DROP_CHANCE_BONUS 0.25
#define ENEMY_CRUMBLER_DROP_CHANCE_BONUS 0.50
#define ENEMY_COLLECTIBLE_DROP_CHANCE_GAME_MULTIPLIER 0.1
#define ENEMY_COLLECTIBLE_DROP_CHANCE_MAX 1.0
#define ENEMY_HIT_TIMER_MAX_MULTIPLIER 5
#define ENEMY_COLLECTIBLE_BULLIONS_DROP_CHANCE 0.10
#define ENEMY_COLLECTIBLE_SACK_DROP_CHANCE 0.25
#define ENEMY_COLLECTIBLE_POWERUP_DROP_CHANCE 0.05

static const SDL_Color ENEMY_SHADOW_COLOR = {0, 0, 0, 64};

Enemy* enemy_add(List* _l, EnemyType _t, Play* _p);
void enemy_set(List* _l, Enemy* _e, f64 _x, f64 _y, Play* _p);
void enemy_update(Enemy* _e, List* _l, Play* _p);
void enemy_damage(Enemy* _e, s32 _d, List* _l, Play* _p);
void enemy_defeat(Enemy* _e, List* _l, Play* _p);
void enemy_remove(List* _l, Enemy* _e, Play* _p);
