/*
 * DESCRIPTION:
 * Gameplay GUI.
*/

#include "gui.h"

/* Initializes GUI. */
void
gui_init(GUI* _g, Play* _p)
{
	gui_cash_init(_g, _p);
	gui_wave_init(_g, _p);
	gui_bounty_init(_g, _p);
	gui_upgrade_init(_g, _p);
	gui_ready_init(_g, _p);
	gui_snake_init(_g, _p);
	gui_redirect_init(_g, _p);
	cursor_init(&_g->cursor, &_p->g->mouse, _p->g->textures[TEXTURE_GUI_CURSOR]);
}

/* Frees GUI. */
void
gui_free(GUI* _g, Play* _p)
{
	gui_cash_free(_g, _p);
	gui_snake_free(_g, _p);
	gui_bounty_free(_g, _p);
	gui_redirect_free(_g, _p);
	gui_ready_free(_g, _p);
	gui_wave_free(_g, _p);
	gui_upgrade_free(_g, _p);
	cursor_free(&_g->cursor);
}

/* Updates GUI. */
void
gui_update(GUI* _g, Play* _p)
{
	gui_cash_update(_g, _p);
	gui_wave_update(_g, _p);
	gui_bounty_update(_g, _p);
	gui_upgrade_update(_g, _p);
	gui_ready_update(_g, _p);
	gui_snake_update(_g, _p);
	gui_redirect_update(_g, _p);
	cursor_update(&_g->cursor, &_p->g->mouse);
}

/* Draws GUI. */
void
gui_draw(GUI* _g, Play* _p)
{
	gui_cash_draw(_g, _p);
	gui_wave_draw(_g, _p);
	gui_bounty_draw(_g, _p);
	gui_upgrade_draw(_g, _p);
	gui_ready_draw(_g, _p);
	gui_snake_draw(_g, _p);
	gui_redirect_draw(_g, _p);
	cursor_draw(&_g->cursor, _p->g->renderer);
}
