/*
 * DESCRIPTION:
 * Displays a ready icon and the current readys available.
*/

#include "gui_ready.h"

/* Initializes ready GUI. */
void 
gui_ready_init(GUI* _g, Play* _p)
{
	Sprite sprite;

	sprite_init
	(
		&_g->readyBackgroundSprite,
		_p->g->textures[TEXTURE_GUI_SIGN_SMALL],
		ORIGIN_MIDDLE,
		GUI_READY_BACKGROUND_WIDTH,
		GUI_READY_BACKGROUND_HEIGHT
	);

	_g->readyBackgroundSprite.x = GUI_READY_OFFSET_X;
	_g->readyBackgroundSprite.y = GUI_READY_OFFSET_Y;

	text_sprite_init
	(
		&sprite,
		_p->g->renderer,
		_p->g->fonts[FONT_SMALL],
		GUI_READY_TEXT_COLOR,
		ORIGIN_MIDDLE,
		STRING_PLAY_GUI_READY,
		GUI_READY_WRAP
	);

	button_init(&_g->readyButton, &sprite);

	_g->readyButton.sprite.x = _g->readyBackgroundSprite.x + GUI_READY_TEXT_OFFSET_X;
	_g->readyButton.sprite.y = _g->readyBackgroundSprite.y + GUI_READY_TEXT_OFFSET_Y;

	_g->readyButton.sprite.rotation = GUI_READY_ROTATION;
}

/* Frees ready GUI. */
void 
gui_ready_free(GUI* _g, Play* _p)
{
	if (_g->readyButton.sprite.atlas.texture)
		texture_free(_g->readyButton.sprite.atlas.texture);
}

/* Updates ready GUI. */
void 
gui_ready_update(GUI* _g, Play* _p)
{
	if (_p->isUpgradesActive)
	{
		button_update(&_g->readyButton, &_p->g->mouse);

		if (_g->readyButton.state == BUTTON_STATE_PRESS)
		{
			_p->isReady = TRUE;
			sound_play(_p->g->sounds[SOUND_GO], -1);
		}
	}
}

/* Draws ready GUI. */
void 
gui_ready_draw(GUI* _g, Play* _p)
{
	if (_p->isUpgradesActive)
	{
		sprite_draw(&_g->readyBackgroundSprite, _p->g->renderer);
		button_draw(&_g->readyButton, _p->g->renderer);
	}
}
