/*
 * DESCRIPTION:
 * Header file for message.c.
*/

#pragma once

#include "../../GAME_COMMON.h"
#include "../../GAME_STRINGS.h"

#define MESSAGE_VELOCITY -1
#define MESSAGE_LIFETIME 60
#define MESSAGE_TEXT_MAX 20

static const SDL_Color MESSAGE_CASH_COLOR = {64, 255, 64, 255};
static const SDL_Color MESSAGE_PURCHASE_COLOR = {255, 64, 64, 255};
static const SDL_Color MESSAGE_MAXED_COLOR = {255, 255, 64, 255};
static const SDL_Color MESSAGE_DAMAGE_COLOR = {255, 64, 64, 255};
static const SDL_Color MESSAGE_WAVE_CLEAR_COLOR = {0, 0, 0, 255};
static const SDL_Color MESSAGE_WAVE_FAIL_COLOR = {255, 64, 64, 255};
static const SDL_Color MESSAGE_GAME_CLEAR_COLOR = {255, 255, 64, 255};
static const SDL_Color MESSAGE_POWER_UP_COLOR = {255, 64, 255, 255};
static const SDL_Color MESSAGE_POWER_DOWN_COLOR = {255, 64, 255, 255};
static const SDL_Color MESSAGE_MIRACLE_CURE_COLOR = {225, 255, 225, 255};
static const SDL_Color MESSAGE_DYNAMITE_COLOR = {0, 0, 0, 255};

Message* message_cash_add(f64 _x, f64 _y, s32 _c, Play* _p);
Message* message_no_cash_add(f64 _x, f64 _y, Play* _p);
Message* message_maxed_add(f64 _x, f64 _y, Play* _p);
Message* message_broke_add(f64 _x, f64 _y, Play* _p);
Message* message_purchase_add(f64 _x, f64 _y, s32 _c, Play* _p);
Message* message_damage_add(f64 _x, f64 _y, s32 _d, Play* _p);
Message* message_wave_clear_add(f64 _x, f64 _y, Play* _p);
Message* message_wave_fail_add(f64 _x, f64 _y, Play* _p);
Message* message_game_clear_add(f64 _x, f64 _y, Play* _p);
Message* message_power_up_add(f64 _x, f64 _y, Play* _p);
Message* message_power_down_add(f64 _x, f64 _y, Play* _p);
Message* message_miracle_cure_add(f64 _x, f64 _y, Play* _p);
Message* message_dynamite_add(f64 _x, f64 _y, Play* _p);
void message_draw(Message* _m, Play* _p);
void message_update(Message* _m, Play* _p);
