/*
 * DESCRIPTION:
 * Handles play messages.
*/

#include "messages.h"

/* Initializes messages. */
void
messages_init(Play* _p)
{
	list_init(&_p->messages);
}

/* Frees messages. */
void
messages_free(Play* _p)
{
	list_free(&_p->messages);
}

/* Updates messages. */
void
messages_update(Play* _p)
{
	Message** messages;
	s32 messageCount;

	messages = (Message**)list_data_get(&_p->messages);
	messageCount = _p->messages.count;

	for (s32 i = 0; i < messageCount; i++)
	{
		Message* m;

		m = messages[i];

		message_update(m, _p);
	}
}

/* Draws messages. */
void
messages_draw(Play* _p)
{
	Message** messages;
	s32 messageCount;

	messages = (Message**)list_data_get(&_p->messages);
	messageCount = _p->messages.count;

	for (s32 i = 0; i < messageCount; i++)
	{
		Message* m;

		m = messages[i];

		message_draw(m, _p);
	}
}
