/*
 * DESCRIPTION:
 * Header file for play.h.
*/

#pragma once

#include "collectible/collectibles.h"
#include "enemy/enemies.h"
#include "player/player.h"
#include "message/messages.h"
#include "pause/pause.h"
#include "gui/gui.h"
#include "spawn/spawn.h"
#include "tutorial/tutorial.h"
#include "wave/wave.h"

#define PLAY_BG_OFFSET_X 0
#define PLAY_BG_OFFSET_Y 0
#define PLAY_BG_WIDTH 800
#define PLAY_BG_HEIGHT 600
#define PLAY_PAUSE_X_OFFSET 400
#define PLAY_PAUSE_Y_OFFSET 300
#define PLAY_PAUSE_RECTANGLE_WIDTH 800
#define PLAY_PAUSE_RECTANGLE_HEIGHT 600

static const SDL_Color PLAY_PAUSE_TEXT_COLOR = {255, 255, 255, 255};
static const SDL_Color PLAY_PAUSE_BACKGROUND_COLOR = {0, 0, 0, 64};

void play_draw(Play* _p);
void play_free(Play* _p);
void play_init(Play* _p, Game* _g);
void play_update(Play* _p);
