/*
 * DESCRIPTION:
 * Player code.
*/

#include "player.h"

/* Initializes player. */
void
player_init(Player* _p, Play* _l)
{
	memset(_p, '\0', sizeof(Player));

	player_fatness_init(_p, _l);
	player_upgrades_init(_p, _l);
	player_price_init(_p, _l);
	player_power_up_init(_p, _l);
	player_fire_init(_p, _l);
	player_shadow_init(_p, _l);
	player_sprite_init(_p, _l);
	player_tail_init(_p, _l);
	player_snakes_init(_p, _l);
	player_direction_init(_p, _l);
	player_movement_init(_p, _l);
	player_defeat_init(_p, _l);
}

/* Frees player. */
void
player_free(Player* _p, Play* _l)
{
	player_sprite_free(_p, _l);
	player_snakes_free(_p, _l);
}

/* Updates player. */
void
player_update(Player* _p, Play* _l)
{
	player_movement_update(_p, _l);
	
	player_cash_update(_p, _l);

	player_power_up_update(_p, _l);

	player_upgrades_update(_p, _l);

	player_price_update(_p, _l);

	player_direction_update(_p, _l);

	player_sprite_update(_p, _l);

	player_tail_update(_p, _l);
	
	player_shadow_update(_p, _l);

	player_fatness_update(_p, _l);

	player_fire_update(_p, _l);
	
	player_snakes_update(_p, _l);

	player_defeat_update(_p, _l);
}

/* Draws player. */
void
player_draw(Player* _p, Play* _l)
{
	player_shadow_draw(_p, _l);


	switch (_p->direction)
	{
		case DIRECTION_LEFT:
		case DIRECTION_DOWN:
		case DIRECTION_RIGHT:
			player_sprite_draw(_p, _l);
			player_tail_draw(_p, _l);
			player_snakes_draw(_p, _l);
			break;
		case DIRECTION_UP:
			player_snakes_draw(_p, _l);
			player_sprite_draw(_p, _l);
			player_tail_draw(_p, _l);
			break;
		default:
			break;
	}

}
