/*
 * DESCRIPTION:
 * Player's cash.
*/

#include "player_cash.h"

/* Adds some cash. */
void
player_cash_acquire(Player* _p, s32 _c, Play* _l)
{
	f64 cash;

	if (_l->game > 1)
		cash = _c * ((_l->game - 1) * PLAYER_CASH_GAME_MULTIPLIER);
	else
		cash = _c;

	_p->cash += (s32)cash;
	_p->cashCollected += (s32)cash;

	message_cash_add(_p->sprite.x, _p->sprite.y, (s32)cash, _l);

	_p->isCashUpdate = TRUE;
}

/* Initializes player cash. */
void
player_cash_init(Player* _p, Play* _l)
{
	_p->cash = 0;

	_p->isCashUpdate = FALSE;
}

/* Updates player cash. */
void
player_cash_update(Player* _p, Play* _l)
{
	_p->cash = CEIL(_p->cash, PLAYER_CASH_MAX);
}
