/* 
 * DESCRIPTION:
 * Functions concering player defeat.
*/

#include "player_defeat.h"

/* The player is defeated. */
void
player_defeat(Player* _p, Play* _l)
{
	list_clear(&_p->snakes);
	list_clear(&_l->collectibles);

	music_stop();

	_p->isBeingDefeated = TRUE;
	_p->defeatTimer = 0;
	_p->isDefeat = TRUE;
}

/* Start the defeat process. */
void
player_defeat_begin(Player* _p, Play* _l)
{
	_p->isBeingDefeated = TRUE;
	_p->defeatTimer = PLAYER_DEFEAT_TIMER_MAX;

	list_clear(&_p->snakes);
	list_clear(&_l->collectibles);

	music_stop();

	_l->isBountyUpdate = TRUE;
}

/* Initializes player defeat. */
void
player_defeat_init(Player* _p, Play* _l)
{
	_p->isDefeat = FALSE;
	_p->isBeingDefeated = FALSE;
	_p->defeatTimer = 0;
}

/* Updates the player defeat. */
void
player_defeat_update(Player* _p, Play* _l)
{
	if (_p->isBeingDefeated)
	{
		_p->defeatTimer--;

		_p->isAbleToFire = FALSE;
		_p->isAbleToMove = FALSE;

		if (_p->defeatTimer <= 0)
			player_defeat(_p, _l);
	}
}
