/*
 * DESCRIPTION:
 * The player's facing direction.
*/

#include "player_direction.h"

/* Initializes player direction. */
void
player_direction_init(Player* _p, Play* _l)
{
	_p->direction = DIRECTION_RIGHT;
}

/* Sets player direction. */
void
player_direction_set(Player* _p, Play* _l)
{
	f64 angle;

	angle = math_atan
	(
		_p->shadow.x,
		_p->shadow.y,
		_l->gui.cursor.sprite.x,
		_l->gui.cursor.sprite.y
	);

	angle *= RAD_TO_DEG;

	if
	(
		angle > PLAYER_DIRECTION_DOWN_THRESHOLD &&
		angle <= PLAYER_DIRECTION_LEFT_THRESHOLD
	)
		_p->direction = DIRECTION_LEFT;
	else if 
	(
		angle > PLAYER_DIRECTION_LEFT_THRESHOLD &&
		angle <= PLAYER_DIRECTION_UP_THRESHOLD
	)
		_p->direction = DIRECTION_UP;
	else if 
	(
		angle > PLAYER_DIRECTION_RIGHT_THRESHOLD &&
		angle <= PLAYER_DIRECTION_DOWN_THRESHOLD
	)
		_p->direction = DIRECTION_DOWN;
	else
		_p->direction = DIRECTION_RIGHT;
}

/* Updates player direction. */
void
player_direction_update(Player* _p, Play* _l)
{
	if 
	(
		_p->isAbleToMove &&
		!_p->isKeyboardMove
	)
		player_direction_set(_p, _l);
}
