/*
 * DESCRIPTION:
 * Player power up behavior. Infinite snakes!!
*/

#include "player_power_up.h"

/* No more power up. */
void
player_power_up_end(Player* _p, Play* _l)
{
	_p->powerUpTimer = 0;
	_p->isPowerUp = FALSE;

	player_snakes_clear(_p, _l);
	_p->snakeReserve = _p->snakeMax;

	message_power_down_add(_p->sprite.x, _p->sprite.y, _l);
}

/* Initializes player power_up. */
void
player_power_up_init(Player* _p, Play* _l)
{
	_p->powerUpTimer = 0;
	_p->isPowerUp = 0;
}

/* Updates player power_up. */
void
player_power_up_update(Player* _p, Play* _l)
{
	if (_p->isPowerUp)
	{
		_p->powerUpTimer--;

		_p->snakeReserve = _p->snakeMax;

		if (_p->powerUpTimer <= 0)
			player_power_up_end(_p, _l);
	}
}
