/* 
 * DESCRIPTION:
 * Functions concering player shadow.
*/

#include "player_shadow.h"

/* Initializes player shadow. */
void
player_shadow_init(Player* _p, Play* _l)
{
        _p->shadow.r = PLAYER_SHADOW_RADIUS[_p->fatness];

	_p->shadow.x = _p->sprite.x + PLAYER_SHADOW_OFFSET_X;
	_p->shadow.y = _p->sprite.y + PLAYER_SHADOW_OFFSET_Y;
}

/* Updates the player shadow. */
void
player_shadow_update(Player* _p, Play* _l)
{
	if (_p->isFatnessUpdate)
		_p->shadow.r = PLAYER_SHADOW_RADIUS[_p->fatness];

	_p->shadow.x = _p->sprite.x + PLAYER_SHADOW_OFFSET_X;
	_p->shadow.y = _p->sprite.y + PLAYER_SHADOW_OFFSET_Y;
}

/* Draws the player shadow. */
void
player_shadow_draw(Player* _p, Play* _l)
{
	shadow_draw(&_p->shadow, _l);
}
