/*
 * DESCRIPTION:
 * Header file for player_snakes.h.
*/

#pragma once

#include "../enemy/enemy.h"

#define PLAYER_SNAKE_ANIMATION_TIMER_MAX 5
#define PLAYER_SNAKE_SHADOW_OFFSET_X 0
#define PLAYER_SNAKE_SHADOW_OFFSET_Y 32
#define PLAYER_SNAKE_SHADOW_RADIUS 8
#define PLAYER_SNAKE_COLUMNS 3
#define PLAYER_SNAKE_DAMAGE_DEFAULT 1
#define PLAYER_SNAKE_FRAME_HEIGHT 32
#define PLAYER_SNAKE_FRAME_WIDTH 48
#define PLAYER_SNAKE_HEIGHT 32
#define PLAYER_SNAKE_OFFSET 32
#define PLAYER_SNAKE_REDIRECT_VELOCITY_MULTIPLIER 0.25
#define PLAYER_SNAKE_REDIRECT_LIFETIME_MULTIPLIER 1.0
#define PLAYER_SNAKE_RETURN_TIMER_MAX 30
#define PLAYER_SNAKE_RETURN_VELOCITY_MULTIPLIER 0.05
#define PLAYER_SNAKE_ROWS 1
#define PLAYER_SNAKE_VELOCITY 7.5
#define PLAYER_SNAKE_WIDTH 48
#define PLAYER_SNAKE_ENEMY_PIERCE_TIMER_MAX 60
#define PLAYER_SNAKE_REDIRECT_ANGLE_DIFFERENCE_MIN 15
#define PLAYER_SNAKE_ARC_WIDTH 96
#define PLAYER_SNAKE_ARC_HEIGHT 96
#define PLAYER_SNAKE_ARC_OFFSET 64

static const SDL_Color PLAYER_SNAKE_SHADOW_COLOR = {0, 0, 0, 64};

void player_snake_add(Player* _p, Play* _l);
void player_snake_reset(Snake* _s, Player* _p, Play* _l);
void player_snakes_clear(Player* _p, Play* _l);
void player_snakes_draw(Player* _p, Play* _l);
void player_snakes_free(Player* _p, Play* _l);
void player_snakes_init(Player* _p, Play* _l);
void player_snakes_update(Player* _p, Play* _l);
