/* 
 * DESCRIPTION:
 * Functions concering player sprite.
*/

#include "player_sprite.h"

/* Initializes player sprite. */
void
player_sprite_init(Player* _p, Play* _l)
{
	Atlas atlas;

	atlas_init
	(
		&atlas,
		_l->g->textures[TEXTURE_PLAYER_STAGE_ONE],
		PLAYER_SPRITE_ROWS,
		PLAYER_SPRITE_COLUMNS,
		PLAYER_SPRITE_WIDTH,
		PLAYER_SPRITE_HEIGHT
	);

        sprite_atlas_init
        (
                &_p->sprite,
                &atlas,
                ORIGIN_MIDDLE,
                PLAYER_SPRITE_WIDTH,
                PLAYER_SPRITE_HEIGHT
        );
	
	_p->sprite.x = PLAYER_SPRITE_X_DEFAULT;
	_p->sprite.y = PLAYER_SPRITE_Y_DEFAULT;
}

/* Frees player sprite. */
void
player_sprite_free(Player* _p, Play* _l)
{


}

/* Updates the player sprite. */
void
player_sprite_update(Player* _p, Play* _l)
{
	if (_p->direction == DIRECTION_LEFT)
		_p->sprite.frame = 0;
	else if (_p->direction == DIRECTION_RIGHT)
		_p->sprite.frame = 1;

	if (_p->isFatnessUpdate)
	{
		/*
		if (_p->isBeingFattened)
		{
			//_p->sprite.atlas.rows = ATLAS_ROWS_DEFAULT;
			//_p->sprite.atlas.cols = ATLAS_COLUMNS_DEFAULT;
			_p->sprite.frame = 0;

			switch (_p->fatness)
			{
				case 0:
					_p->sprite.atlas.texture = _l->g->textures[TEXTURE_PLAYER_STAGE_ONE];
					//_p->sprite.atlas.texture = _l->g->textures[TEXTURE_PLAYER_SWALLOW_ONE];
					break;
				case 1:
					_p->sprite.atlas.texture = _l->g->textures[TEXTURE_PLAYER_STAGE_ONE];
					//_p->sprite.atlas.texture = _l->g->textures[TEXTURE_PLAYER_SWALLOW_TWO];
					break;
				case 2:
					_p->sprite.atlas.texture = _l->g->textures[TEXTURE_PLAYER_STAGE_ONE];
					//_p->sprite.atlas.texture = _l->g->textures[TEXTURE_PLAYER_SWALLOW_THREE];
					break;
				default:
					break;
			}
		}
		else
		{
		*/
			_p->sprite.atlas.rows = PLAYER_SPRITE_ROWS;
			_p->sprite.atlas.cols = PLAYER_SPRITE_COLUMNS;

			switch (_p->fatness)
			{
				case 0:
					_p->sprite.atlas.texture = _l->g->textures[TEXTURE_PLAYER_STAGE_ONE];
					break;
				case 1:
					_p->sprite.atlas.texture = _l->g->textures[TEXTURE_PLAYER_STAGE_TWO];
					break;
				case 2:
					_p->sprite.atlas.texture = _l->g->textures[TEXTURE_PLAYER_STAGE_THREE];
					break;
				default:
					break;
			}
		/*
		}
		*/
	}
}

/* Draws the player sprite. */
void
player_sprite_draw(Player* _p, Play* _l)
{
	sprite_draw(&_p->sprite, _l->g->renderer);
}
