/*
 * DESCRIPTION:
 * Displays some helpful tutorial text at the start of the game.
*/

#include "tutorial.h"

/* Initializes tutorial stuff. */
void
tutorial_init(Play* _p)
{
	if (_p->player.isKeyboardMove)
	{
		text_sprite_init
		(
			&_p->tutorialText,
			_p->g->renderer,
			_p->g->fonts[FONT_SMALL],
			TUTORIAL_TEXT_COLOR,
			ORIGIN_MIDDLE,
			STRING_PLAY_TUTORIAL_KEYBOARD,
			TUTORIAL_TEXT_WRAP
		);
	}
	else
	{
		text_sprite_init
		(
			&_p->tutorialText,
			_p->g->renderer,
			_p->g->fonts[FONT_SMALL],
			TUTORIAL_TEXT_COLOR,
			ORIGIN_MIDDLE,
			STRING_PLAY_TUTORIAL_MOUSE,
			TUTORIAL_TEXT_WRAP
		);
	}

	_p->tutorialText.x = TUTORIAL_TEXT_OFFSET_X;
	_p->tutorialText.y = TUTORIAL_TEXT_OFFSET_Y;

	_p->isTutorial = TRUE;
	_p->tutorialTimer = TUTORIAL_TIMER_MAX;
}

/* Frees tutorial stuff. */
void
tutorial_free(Play* _p)
{
	if (_p->tutorialText.atlas.texture)
		texture_free(_p->tutorialText.atlas.texture);
}

/* Updates tutorial stuff. */
void
tutorial_update(Play* _p)
{
	if (_p->isTutorial)
	{
		f64 progress;

		_p->tutorialTimer--;

		progress = (f64)_p->tutorialTimer / TUTORIAL_TIMER_MAX;

		_p->tutorialText.color.a = SDL_ALPHA_OPAQUE * progress;

		if (_p->tutorialTimer <= 0)
			_p->isTutorial = FALSE;
	}
}

/* Draws tutorial stuff. */
void
tutorial_draw(Play* _p)
{
	if (_p->isTutorial)
		sprite_draw(&_p->tutorialText, _p->g->renderer);
}
