/*
 * DESCRIPTION:
 * Header file for wave.c.
*/

#pragma once

#include "../player/player_cash.h"
#include "../player/player_snakes.h"
#include "../player/player_sprite.h"
#include "../player/player_power_up.h"

#define GAME_DEFAULT 1
#define WAVE_GRACE_PERIOD_TIMER_MAX 300
#define WAVE_DEFAULT 1
#define WAVE_ENEMY_COUNT_BASE_MAX_MULTIPLIER 1.25
#define WAVE_ENEMY_COUNT_BASE_MIN_MULTIPLIER 0.75
#define WAVE_ENEMY_COUNT_GAME_MULTIPLIER 1.25
#define WAVE_ENEMY_COUNT_MULTIPLIER 1.25
#define WAVE_MAX 10
#define WAVE_ENEMY_COUNT_BASE 5
#define WAVE_REWARD_GAME_MULTIPLIER 2
#define WAVE_REWARD_MULTIPLIER 10
#define WAVE_BETWEEN_TIMER_MAX 180
#define WAVE_GAME_CLEAR_TIMER_MAX 300

#define WAVE_ONE_ENEMY_TYPE_COUNT 1
#define WAVE_TWO_ENEMY_TYPE_COUNT 1
#define WAVE_THREE_ENEMY_TYPE_COUNT 1
#define WAVE_FOUR_ENEMY_TYPE_COUNT 2
#define WAVE_FIVE_ENEMY_TYPE_COUNT 2
#define WAVE_SIX_ENEMY_TYPE_COUNT 2
#define WAVE_SEVEN_ENEMY_TYPE_COUNT 3
#define WAVE_EIGHT_ENEMY_TYPE_COUNT 3
#define WAVE_NINE_ENEMY_TYPE_COUNT 1
#define WAVE_TEN_ENEMY_TYPE_COUNT 4

static const EnemyType WAVE_ONE[WAVE_ONE_ENEMY_TYPE_COUNT] = 
{
	ENEMY_CUPPER
};

static const EnemyType WAVE_TWO[WAVE_TWO_ENEMY_TYPE_COUNT] = 
{
	ENEMY_CHIPPER
};

static const EnemyType WAVE_THREE[WAVE_THREE_ENEMY_TYPE_COUNT] = 
{
	ENEMY_CRUMBLER
};

static const EnemyType WAVE_FOUR[WAVE_FOUR_ENEMY_TYPE_COUNT] = 
{
	ENEMY_CUPPER,
	ENEMY_CHIPPER
};

static const EnemyType WAVE_FIVE[WAVE_FIVE_ENEMY_TYPE_COUNT] = 
{
	ENEMY_CUPPER,
	ENEMY_CRUMBLER
};

static const EnemyType WAVE_SIX[WAVE_SIX_ENEMY_TYPE_COUNT] = 
{
	ENEMY_CHIPPER,
	ENEMY_CRUMBLER,
};

static const EnemyType WAVE_SEVEN[WAVE_SEVEN_ENEMY_TYPE_COUNT] = 
{
	ENEMY_CUPPER,
	ENEMY_CHIPPER,
	ENEMY_CRUMBLER
};

static const EnemyType WAVE_EIGHT[WAVE_EIGHT_ENEMY_TYPE_COUNT] = 
{
	ENEMY_CUPPER,
	ENEMY_CHIPPER,
	ENEMY_CRUMBLER
};

static const EnemyType WAVE_NINE[WAVE_NINE_ENEMY_TYPE_COUNT] = 
{
	ENEMY_CHIP
};

static const EnemyType WAVE_TEN[WAVE_TEN_ENEMY_TYPE_COUNT] = 
{
	ENEMY_CUPPER,
	ENEMY_CHIPPER,
	ENEMY_CRUMBLER,
	ENEMY_CHIP
};

void wave_init(Play* _p);
void wave_update(Play* _p);
void wave_new_game_plus(Play* _p);
