#include "main.h"

static void loop(void);
static void init(void);
static void quit(void);

static Game g;

static void
init(void)
{
	sdl_init();

	random_seed_set();

	game_init(&g);
}

static void
quit(void)
{
	/*
	if (g.isFullScreen)
	{
		window_fullscreen_exit(g.window);
		g.isFullScreen = FALSE;
	}
	*/

	game_free(&g);
	sdl_quit();
	exit(1);
}

static void
loop(void)
{
	game_loop(&g);

	if (event_press(&g.event, EVENT_QUIT))
		quit();
}

s32 
main(s32 argc, char* argv[])
{
	init();

#ifdef EMSCRIPTEN
	emscripten_set_main_loop(loop, FPS, TRUE);
#else
	while (TRUE)
		loop();
#endif
	return 1;
}
